/*
* Program Name: anotposc.c
* Vers  : 1.1
* Author: Skip Moon
*
* syntax: <position_in_array> = anotpos( <array>, <var_all_must_match>
*                                        [ ,<begin_pos>, <end_pos> ])
*
* Copyright (c) 1989 by Moon Microsystems 
*---------------------------- ALL RIGHTS RESERVED ----------------------------
*/

#include <extend.h>

CLIPPER anotpos( void )
{

    int notpos=0, i, j, arlen, srchtype, srchsize, elsize, begpos, endpos;
    char *ss, *as;

    if ( (!ISARRAY(1)) || PCOUNT < 2 || !ISNUM(2) )
        _retni( -1 );   /* error */

    srchtype = _parinfo(2);
    arlen    = ALENGTH(1);

    
    if ( PCOUNT==4 && ISNUM(3) && ISNUM(4) ){  /* if start and end position */
        begpos = _parni(3);
        if (begpos<1 || begpos>arlen )
            begpos=1;
        endpos = _parni(4);
        if (endpos<begpos || endpos>arlen)
            endpos=arlen;

    } else {

        if ( PCOUNT==3 && ISNUM(3) ){          /* if start position */
            if (begpos<1 || begpos>arlen )
                begpos=1;
            endpos = arlen;

        } else {

            begpos = 1;                        /* default */
            endpos = arlen;
        }
    }


    switch (srchtype) {
        case CHARACTER :
            srchsize = _parclen(2);

            for (i=begpos; i<=endpos; i++){
                if (_parinfa(1,i)!=CHARACTER){
                    notpos=i;
                    break;
                }
                else{
                    elsize = _parclen(1,i);
                    if (srchsize!=elsize){
                        notpos=i;
                        break;
                    }
                    else{
                        ss=_parc(2);
                        as=_parc(1,i);

                        for (j=0; j<elsize; j++){
                            if ( *(ss++) != *(as++) ){
                                notpos=i;
                                _retni( notpos );
                                return;
                            }
                        }
                    }
                }
            }
            break;

              
        case NUMERIC :

            for (i=begpos; i<=endpos; i++){
                if (_parinfa(1,i)==NUMERIC){
                    if ( _parnd(2) !=_parnd(1,i) ) {
                        notpos=i;
                        break;
                    }
                    
                }else{
                    notpos=i;
                    break;
                }
            }
            break;


        case LOGICAL :

            for (i=begpos; i<=endpos; i++){
                if (_parinfa(1,i)==LOGICAL){
                    if ( _parl(2) !=_parl(1,i) ) {
                        notpos=i;
                        break;
                    }
                    
                }else{
                    notpos=i;
                    break;
                }
            }
            break;





        case DATE :

            srchsize = _parclen(2);

            for (i=begpos=1; i<=endpos; i++){
                if (_parinfa(1,i)!=DATE){
                    notpos=i;
                    break;
                }
                else{
                    elsize = _parclen(1,i);
                    if (srchsize!=elsize){
                        notpos=i;
                        break;
                    }
                    else{
                        ss=_pards(2);
                        as=_pards(1,i);

                        for (j=0; j<elsize; j++){
                            if ( *(ss++) != *(as++) ){
                                notpos=i;
                                _retni( notpos );
                                return;
                            }
                        }
                    }
                }
            }
            break;

        default :
            _retni(-1);
            return;

    }
    _retni( notpos );

}
